/////////////////////////////////////////////////////////////////////////////////
// Company       : 人о·Ƽ޹˾
//                 http://xiaomeige.taobao.com
// Web           : http://www.corecourse.cn
// 
// Create Date   : 2019/05/01 00:00:00
// Module Name   : state_ctrl
// Description   : ADCɼDDR3洮ڷ״̬ģ
// 
// Dependencies  : 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
/////////////////////////////////////////////////////////////////////////////////

module state_ctrl(
   	input clk,
	input reset,
	
	input [31:0]DataNum,    //βɼݸ
    input RestartReq,       //ʼź
    input [7:0]ChannelSel,  //Ҫͨѡ  ÿһλӦһͨĿ
    
    input [7:0]adc_data_flag,      //ÿͨĽ֮󣬾Ͳһ Flag źţ֪ͨⲿȡ
    
	input ddr3_init_done,
	input uart_tx_done,
	input rdfifo_empty,
	input [15:0]rdfifo_dout,
	input wrfifo_full,	
	//wrfifo_clr֤wrfifoźŵЧ
	output reg wrfifo_clr,
	output reg ad_sample_en,

	output reg wrfifo_wren,
	output reg rdfifo_clr,
	output reg rdfifo_rden,
	output reg uart_send_en,
	output reg[7:0]uart_tx_data	,
    input Conv,                         //תʱ,ֹʹڲʱ
	output reg ddrwrreq                //ɼдddrź
);
    reg [4:0]state; //״̬ĸ
    reg [31:0]adc_sample_cnt; //ͳADCDDR͵
    reg [31:0]send_data_cnt;  //ͳ򴮿ڷADCݵĸ
    reg start_sample_rm;  //start_sample_rmвֻIDLE״̬йЧ״̬Ч
    reg [4:0]wrfifo_clr_cnt;    
    reg [4:0]rdfifo_clr_cnt;
    reg [15:0]fiforddata_rm;
    reg [3:0] skip_cnt;
    
    localparam IDLE                   = 4'd0;
	localparam DDR_WR_FIFO_CLEAR      = 4'd1;
    localparam ADC_CONV               = 4'd2;    //ȴ
	localparam ADC_SAMPLE             = 4'd3;
	localparam DDR_RD_FIFO_CLEAR      = 4'd4;
	localparam DATA_SEND_DELAY1       = 4'd5;
	localparam DATA_SEND_DELAY2       = 4'd6;
	localparam DATA_SEND_LOW_START    = 4'd7;
	localparam DATA_SEND_LOW_WORKING  = 4'd8;
	localparam DATA_SEND_HIGH_START   = 4'd9;
	localparam DATA_SEND_HIGH_WORKING = 4'd10;
	localparam DATA_SWITCH            = 4'd11;
	
   reg [3:0] SKIP_SAMPLES;
	  
    always@(posedge clk or posedge reset)begin	//ȥͨһ
    if(reset)
        SKIP_SAMPLES <= #1  1'b0;
    else if(ad_sample_en)
        SKIP_SAMPLES <= ChannelSel[0] + ChannelSel[1] + ChannelSel[2] + ChannelSel[3] +	
                    ChannelSel[4] + ChannelSel[5] + ChannelSel[6] + ChannelSel[7];
    else 
        SKIP_SAMPLES <= SKIP_SAMPLES;
    end
	
	always@(posedge clk or posedge reset)
	if(reset)begin
		state<=IDLE;
		rdfifo_rden <= 1'b0;
		uart_send_en <= 1'b0;
		uart_tx_data<=8'd0;
	end
	else
	case(state)
	   	IDLE: //0
            begin
            if(start_sample_rm)begin
                state<=DDR_WR_FIFO_CLEAR;  
                end
            else
                state<=state;
            end

		DDR_WR_FIFO_CLEAR: //1
            begin
            if(!wrfifo_full && (wrfifo_clr_cnt==9))
                state<=ADC_CONV;
            else
                state<=DDR_WR_FIFO_CLEAR;
            end
            
        ADC_CONV://2
            begin
                if(Conv)
                    state<=ADC_SAMPLE;
                else
                    state<=state;
            end

		ADC_SAMPLE: //3
            begin
            if( adc_sample_cnt >=DataNum + SKIP_SAMPLES)
                state<=DDR_RD_FIFO_CLEAR;
            else
                state<=state;
            end

		DDR_RD_FIFO_CLEAR: //4
            begin
            if(!rdfifo_empty && (rdfifo_clr_cnt==9))
                state<=DATA_SEND_DELAY1;
            else
                state<=state;
            end

		DATA_SEND_DELAY1: //5
            begin
                state <= DATA_SEND_DELAY2;
                rdfifo_rden <= 1'b1;
            end

		DATA_SEND_DELAY2: //6
            begin
                state <= DATA_SEND_LOW_START;
                rdfifo_rden <= 1'b0;
            end

		DATA_SEND_LOW_START: //7
            begin
                state <= DATA_SEND_LOW_WORKING;
                uart_send_en <= 1'b1;     //*//ߴڣҪ͵ѾλĿǰⷢ͵8λ
                uart_tx_data <= fiforddata_rm[7:0];
                rdfifo_rden <= 1'b0;
            end

		DATA_SEND_LOW_WORKING: //8
            begin
                uart_send_en <= 1'b0;
            if(uart_tx_done)
                state <= DATA_SEND_HIGH_START;
            else
                state <= DATA_SEND_LOW_WORKING;
            end

		DATA_SEND_HIGH_START: //9
            begin
                state <= DATA_SEND_HIGH_WORKING;
                uart_send_en <= 1'b1;		//*//ߴڣҪ͵ѾλĿǰⷢ͸8λ
                uart_tx_data <= fiforddata_rm[15:8];
            end

		DATA_SEND_HIGH_WORKING: //10
            begin
                uart_send_en <= 1'b0;
            if(uart_tx_done)//*//ٴյڷźţѭСѭѡ״̬
                state <= DATA_SWITCH;
            else
                state <= DATA_SEND_HIGH_WORKING;
            end

		DATA_SWITCH: //11
            begin
                rdfifo_rden <= 1'b0;
                if(send_data_cnt>=DataNum)//*//send_data_cntڷͼڸֵ,תIDLE״̬//ݿ鷢ɣѭտ
                    state <= IDLE;
                else 
                    state <= DATA_SEND_DELAY1;//*//һ˫ֽڷɣDATA_SEND_DELAY1״̬Сѭտ
            end

		default://ĬΪ״̬ڷͲʹܣȡfifo
            begin
                state <= IDLE;
                uart_send_en <= 1'b0;
                rdfifo_rden <= 1'b0;
            end
	endcase
	
	always@(posedge clk or posedge reset)begin  //ԲʼλмĴ棬ͬʱ޶ֻ״̬IDLE
	if(reset)
		start_sample_rm <= 1'b0;
	else if(state==IDLE && ddr3_init_done==1'b1)
		start_sample_rm <= RestartReq;
	else 
		start_sample_rm <= 1'b0;
	end	
	
	always@(posedge clk or posedge reset)begin//*//DDRдFIFOļ10ĺָ״̬ת
	if(reset)
		wrfifo_clr_cnt<=0;
	else if(state==DDR_WR_FIFO_CLEAR)//fifo״̬
	begin 
		if(wrfifo_clr_cnt==9)
			wrfifo_clr_cnt<=4'd9;
		else
			wrfifo_clr_cnt<=wrfifo_clr_cnt+1'b1;
	end
	else
		wrfifo_clr_cnt<=1'b0;
	end	
	
//*//ʼɹ󣬽һfifo
//*DDR_WR_FIFO_CLEAR״̬wrfifo_clr_cntΪ0,12ʱдfifo1wrfifo_clrΪ0*//
	always@(posedge clk or posedge reset)begin
	if (reset)
		wrfifo_clr<=0;
	else if(ddr3_init_done==1'b0)
		wrfifo_clr<=1'b1;
	else if(state==DDR_WR_FIFO_CLEAR)
        begin
            if(wrfifo_clr_cnt==0||wrfifo_clr_cnt==1||wrfifo_clr_cnt==2)
                wrfifo_clr<=1'b1;
            else
                wrfifo_clr<=1'b0;
        end
	else 
		wrfifo_clr<=1'b0;
	end
	
//	always@(posedge clk or posedge reset)begin
//    if(reset)
//		wrfifo_wren<=0;
//    else if(state==ADC_SAMPLE)
//		wrfifo_wren<=1;
//    else
//		wrfifo_wren<=0;
//	end
    
	   
	always@(posedge clk or posedge reset)begin
    if(reset)
		ad_sample_en<=0;
	else if(state==ADC_SAMPLE)
		ad_sample_en<=1;
	else
		ad_sample_en<=0;
	end		
	
    always@(posedge clk or posedge reset)begin	//ݸţȥǰSKIP_SAMPLES
    if(reset)
        skip_cnt <= 4'd0;
    else if (RestartReq)
        skip_cnt <= 4'd0;
    else if (ad_sample_en && (adc_data_flag & ChannelSel) && skip_cnt < SKIP_SAMPLES)
        skip_cnt <= skip_cnt + 1;
    end
	
	always@(posedge clk)
      ddrwrreq <= (adc_data_flag & ChannelSel)  && ad_sample_en && (skip_cnt>=SKIP_SAMPLES);
	
////adc_sample_cntADC_SAMPLE״̬ÿʱԼ1
	always@(posedge clk or posedge reset)begin  
    if(reset)                                  
		adc_sample_cnt<=1'b0;
    else if(ad_sample_en)begin
        if(adc_data_flag & ChannelSel)
		  adc_sample_cnt<=adc_sample_cnt+1'b1;
		else
		  adc_sample_cnt<=adc_sample_cnt;
	end
    else
		adc_sample_cnt<=1'b0;
	end
	
	////DDRFIFOļ10ĺָ״̬ת
	always@(posedge clk or posedge reset)begin
    if(reset)
		rdfifo_clr_cnt<=0;
    else if(state==DDR_RD_FIFO_CLEAR)//fifo״̬
    begin 
		if(rdfifo_clr_cnt==9)
			rdfifo_clr_cnt<=4'd9;
		else
			rdfifo_clr_cnt<=rdfifo_clr_cnt+1'b1;
    end
    else
		rdfifo_clr_cnt<=1'b0;
	end
	
	always@(posedge clk or posedge reset)begin
    if (reset)
		rdfifo_clr<=0;
    else if(ddr3_init_done==1'b0)
		rdfifo_clr<=1'b1;
    else if(state==DDR_RD_FIFO_CLEAR)
    begin
		if(rdfifo_clr_cnt==0||rdfifo_clr_cnt==1||rdfifo_clr_cnt==2)
			rdfifo_clr<=1'b1;
     else
			rdfifo_clr<=1'b0;
    end
    else 
		rdfifo_clr<=1'b0;
	end
	
	always@(posedge clk or posedge reset)begin
    if(reset)
		fiforddata_rm<=16'b0;
    else if(rdfifo_rden)
		fiforddata_rm<=rdfifo_dout;
    else 
		fiforddata_rm<=fiforddata_rm;
	end
	
/*ÿsend_data_cntrdfifo_rdenΪ1״̬¼1
rdfifo_rdenΪÿֻһģ
֤ÿζ16bitʱsend_data_cntֻ1*/
	always@(posedge clk or posedge reset)begin  
    if(reset)
		send_data_cnt<=1'b0;
    else if(state==IDLE)
		send_data_cnt<=1'b0;
    else if(rdfifo_rden)
		send_data_cnt<=send_data_cnt+1;
    else 
		send_data_cnt<=send_data_cnt;
	end	
	
endmodule